searchNodes=[{"doc":"HTTP/1 and HTTP/2 WebSocket support for the Mint functional HTTP client Like Mint, Mint.WebSocket provides a functional, process-less interface for operating a WebSocket connection. Prospective Mint.WebSocket users may wish to first familiarize themselves with Mint.HTTP . Mint.WebSocket is not fully spec-conformant on its own. Runtime behaviors such as responding to pings with pongs must be implemented by the user of Mint.WebSocket. Usage A connection formed with Mint.HTTP.connect/4 can be upgraded to a WebSocket connection with upgrade/5 . { :ok , conn } = Mint.HTTP . connect ( :http , &quot;localhost&quot; , 9_000 ) { :ok , conn , ref } = Mint.WebSocket . upgrade ( :ws , conn , &quot;/&quot; , [ ] ) upgrade/5 sends an upgrade request to the remote server. The WebSocket connection is then built by awaiting the HTTP response from the server. http_reply_message = receive ( do : ( message -&gt; message ) ) { :ok , conn , [ { :status , ^ ref , status } , { :headers , ^ ref , resp_headers } , { :done , ^ ref } ] } = Mint.WebSocket . stream ( conn , http_reply_message ) { :ok , conn , websocket } = Mint.WebSocket . new ( conn , ref , status , resp_headers ) Once the WebSocket connection has been established, use the websocket data structure to encode and decode frames with encode/2 and decode/2 , and send and stream messages with stream_request_body/3 and stream/2 . For example, one may send a &quot;hello world&quot; text frame across a connection like so: { :ok , websocket , data } = Mint.WebSocket . encode ( websocket , { :text , &quot;hello world&quot; } ) { :ok , conn } = Mint.WebSocket . stream_request_body ( conn , ref , data ) Say that the remote is echoing messages. Use stream/2 and decode/2 to decode a received WebSocket frame: echo_message = receive ( do : ( message -&gt; message ) ) { :ok , conn , [ { :data , ^ ref , data } ] } = Mint.WebSocket . stream ( conn , echo_message ) { :ok , websocket , [ { :text , &quot;hello world&quot; } ] } = Mint.WebSocket . decode ( websocket , data ) HTTP/2 Support Mint.WebSocket supports WebSockets over HTTP/2 as defined in rfc8441. rfc8441 is an extension to the HTTP/2 specification. At the time of writing, very few HTTP/2 server libraries support or enable HTTP/2 WebSockets by default. upgrade/5 works on both HTTP/1 and HTTP/2 connections. In order to select HTTP/2, the :http2 protocol should be explicitly selected in Mint.HTTP.connect/4 . { :ok , conn } = Mint.HTTP . connect ( :http , &quot;websocket.example&quot; , 80 , protocols : [ :http2 ] ) :http2 = Mint.HTTP . protocol ( conn ) { :ok , conn , ref } = Mint.WebSocket . upgrade ( :ws , conn , &quot;/&quot; , [ ] ) If the server does not support the extended CONNECT method needed to bootstrap WebSocket connections over HTTP/2, upgrade/4 will return an error tuple with the :extended_connect_disabled error reason. { :error , conn , % Mint.WebSocketError { reason : :extended_connect_disabled } } Why use HTTP/2 for WebSocket connections in the first place? HTTP/2 can multiplex many requests over the same connection, which can reduce the latency incurred by forming new connections for each request. A WebSocket connection only occupies one stream of a HTTP/2 connection, so even if an HTTP/2 connection has an open WebSocket communication, it can be used to transport more requests. WebSocket Secure Encryption of connections is handled by Mint functions. To start a WSS connection, select :https as the scheme in Mint.HTTP.connect/4 : { :ok , conn } = Mint.HTTP . connect ( :https , &quot;websocket.example&quot; , 443 ) And pass the :wss scheme to upgrade/5 . See the Mint documentation on SSL for more information. Extensions The WebSocket protocol allows for extensions . Extensions act as a middleware for encoding and decoding frames. For example &quot;permessage-deflate&quot; compresses and decompresses the body of data frames, which minifies the amount of bytes which must be sent over the network. See Mint.WebSocket.Extension for more information about extensions and Mint.WebSocket.PerMessageDeflate for information about the &quot;permessage-deflate&quot; extension.","ref":"Mint.WebSocket.html","title":"Mint.WebSocket","type":"module"},{"doc":"Decodes a binary into a list of frames The binary may received from the connection with Mint.HTTP.stream/2 . This function will invoke the Mint.WebSocket.Extension.decode/2 callback for any accepted extensions. Examples message = receive ( do : ( message -&gt; message ) ) { :ok , conn , [ { :data , ^ ref , data } ] } = Mint.HTTP . stream ( conn , message ) { :ok , websocket , frames } = Mint.WebSocket . decode ( websocket , data )","ref":"Mint.WebSocket.html#decode/2","title":"Mint.WebSocket.decode/2","type":"function"},{"doc":"Encodes a frame into a binary The resulting binary may be sent with stream_request_body/3 . This function will invoke the Mint.WebSocket.Extension.encode/2 callback for any accepted extensions. Examples { :ok , websocket , data } = Mint.WebSocket . encode ( websocket , { :text , &quot;hello world&quot; } ) { :ok , conn } = Mint.WebSocket . stream_request_body ( conn , websocket_ref , data )","ref":"Mint.WebSocket.html#encode/2","title":"Mint.WebSocket.encode/2","type":"function"},{"doc":"Creates a new WebSocket data structure given the server's reply to the upgrade request This function will setup any extensions accepted by the server using the Mint.WebSocket.Extension.init/2 callback. Options :mode - (default: :active ) either :active or :passive . This corresponds to the same option in Mint.HTTP.connect/4 . Examples http_reply = receive ( do : ( message -&gt; message ) ) { :ok , conn , [ { :status , ^ ref , status } , { :headers , ^ ref , headers } , { :done , ^ ref } ] } = Mint.WebSocket . stream ( conn , http_reply ) { :ok , conn , websocket } = Mint.WebSocket . new ( :ws , conn , ref , status , resp_headers )","ref":"Mint.WebSocket.html#new/5","title":"Mint.WebSocket.new/5","type":"function"},{"doc":"Receives data from the socket This function is used instead of stream/2 when the connection is in :passive mode. You must pass the mode: :passive option to new/5 in order to use recv/3 . This function wraps Mint.HTTP.recv/3 . See the Mint.HTTP.recv/3 documentation for more information. Examples { :ok , conn , [ { :data , ^ ref , data } ] } = Mint.WebSocket . recv ( conn , 0 , 5_000 ) { :ok , websocket , [ { :text , &quot;hello world!&quot; } ] } = Mint.WebSocket . decode ( websocket , data )","ref":"Mint.WebSocket.html#recv/3","title":"Mint.WebSocket.recv/3","type":"function"},{"doc":"A wrapper around Mint.HTTP.stream/2 for streaming HTTP and WebSocket messages This function does not decode WebSocket frames. Instead, once a WebSocket connection has been established, decode any {:data, request_ref, data} frames with decode/2 . This function is a drop-in replacement for Mint.HTTP.stream/2 which enables streaming WebSocket data after the bootstrapping HTTP/1 connection has concluded. It decodes both WebSocket and regular HTTP messages. Examples message = receive ( do : ( message -&gt; message ) ) { :ok , conn , [ { :data , ^ websocket_ref , data } ] } = Mint.WebSocket . stream ( conn , message ) { :ok , websocket , [ { :text , &quot;hello world!&quot; } ] } = Mint.WebSocket . decode ( websocket , data )","ref":"Mint.WebSocket.html#stream/2","title":"Mint.WebSocket.stream/2","type":"function"},{"doc":"Streams chunks of data on the connection stream_request_body/3 should be used to send encoded data on an established WebSocket connection that has already been upgraded with upgrade/5 . This function is a wrapper around Mint.HTTP.stream_request_body/3 . It delegates to that function unless the request_ref belongs to an HTTP/1 WebSocket connection. When the request is an HTTP/1 WebSocket, this function allows sending data on a request which Mint considers to be closed, but is actually a valid WebSocket connection. See the Mint.HTTP.stream_request_body/3 documentation for more information. Examples { :ok , websocket , data } = Mint.WebSocket . encode ( websocket , { :text , &quot;hello world!&quot; } ) { :ok , conn } = Mint.WebSocket . stream_request_body ( conn , websocket_ref , data )","ref":"Mint.WebSocket.html#stream_request_body/3","title":"Mint.WebSocket.stream_request_body/3","type":"function"},{"doc":"Requests that a connection be upgraded to the WebSocket protocol This function wraps Mint.HTTP.request/5 to provide a single interface for bootstrapping an upgrade for HTTP/1 and HTTP/2 connections. For HTTP/1 connections, this function performs a GET request with WebSocket-specific headers. For HTTP/2 connections, this function performs an extended CONNECT request which opens a stream to be used for the WebSocket connection. The scheme argument should be either :ws or :wss , using :ws for connections established by passing :http to Mint.HTTP.connect/4 and :wss corresponding to :https . Options :extensions - a list of extensions to negotiate. See the extensions section below. Extensions Extensions should be declared by passing the :extensions option in the opts keyword list. Note that in the WebSocket protocol, extensions are negotiated: the client proposes a list of extensions and the server may accept any (or none) of them. See Mint.WebSocket.Extension for more information about extension negotiation. Extensions may be passed as a list of Mint.WebSocket.Extension structs or with the following shorthand notations: module - shorthand for {module, []} {module, params} - shorthand for {module, params, []} {module, params, opts} - a shorthand which is expanded to a Mint.WebSocket.Extension struct Examples { :ok , conn } = Mint.HTTP . connect ( :http , &quot;localhost&quot; , 9_000 ) { :ok , conn , ref } = Mint.WebSocket . upgrade ( :ws , conn , &quot;/&quot; , [ ] , extensions : [ Mint.WebSocket.PerMessageDeflate ] ) # or provide params: { :ok , conn , ref } = Mint.WebSocket . upgrade ( :ws , conn , &quot;/&quot; , [ ] , extensions : [ { Mint.WebSocket.PerMessageDeflate , [ :client_max_window_bits ] ] } ] )","ref":"Mint.WebSocket.html#upgrade/5","title":"Mint.WebSocket.upgrade/5","type":"function"},{"doc":"","ref":"Mint.WebSocket.html#t:error/0","title":"Mint.WebSocket.error/0","type":"type"},{"doc":"A WebSocket frame {:binary, binary} - a frame containing binary data. Binary frames can be used to send arbitrary binary data such as a PDF. {:text, text} - a frame containing string data. Text frames must be valid utf8. Elixir has wonderful support for utf8: String.valid?/1 can detect valid and invalid utf8. {:ping, binary} - a control frame which the server should respond to with a pong. The binary data must be echoed in the pong response. {:pong, binary} - a control frame which forms a reply to a ping frame. Pings and pongs may be used to check the a connection is alive or to estimate latency. {:close, code, reason} - a control frame used to request that a connection be closed or to acknowledgee a close frame send by the server. These may be passed to encode/2 or returned from decode/2 . Close frames In order to close a WebSocket connection gracefully, either the client or server sends a close frame. Then the other endpoint responds with a close with code 1_000 and then closes the TCP connection. This can be accomplished in Mint.WebSocket like so: { :ok , websocket , data } = Mint.WebSocket . encode ( websocket , :close ) { :ok , conn } = Mint.WebSocket . stream_request_body ( conn , ref , data ) close_response = receive ( do : ( message -&gt; message ) ) { :ok , conn , [ { :data , ^ ref , data } ] } = Mint.WebSocket . stream ( conn , close_response ) { :ok , websocket , [ { :close , 1_000 , &quot;&quot; } ] } = Mint.WebSocket . decode ( websocket , data ) Mint.HTTP . close ( conn ) rfc6455 section 7.4.1 documents codes which may be used in the code element.","ref":"Mint.WebSocket.html#t:frame/0","title":"Mint.WebSocket.frame/0","type":"type"},{"doc":"Shorthand notations for control frames :ping - shorthand for {:ping, &quot;&quot;} :pong - shorthand for {:pong, &quot;&quot;} :close - shorthand for {:close, nil, nil} These may be passed to encode/2 . Frames decoded with decode/2 are always in frame/0 format.","ref":"Mint.WebSocket.html#t:shorthand_frame/0","title":"Mint.WebSocket.shorthand_frame/0","type":"type"},{"doc":"An immutable data structure representing a WebSocket connection","ref":"Mint.WebSocket.html#t:t/0","title":"Mint.WebSocket.t/0","type":"opaque"},{"doc":"Tools for defining extensions to the WebSocket protocol The WebSocket protocol allows for extensions which act as middle-ware in the encoding and decoding of frames. In Mint.WebSocket , extensions are written as module which implement the Mint.WebSocket.Extension behaviour. The common &quot;permessage-deflate&quot; extension is built-in to Mint.WebSocket as Mint.WebSocket.PerMessageDeflate . This extension should be used as a reference when writing future extensions, but future extensions should be written as separate libraries which extend Mint.WebSocket instead of built-in. Also note that extensions must operate on the internal representations of frames using the records defined in Mint.WebSocket.Frame , which are not documented.","ref":"Mint.WebSocket.Extension.html","title":"Mint.WebSocket.Extension","type":"behaviour"},{"doc":"Invoked when decoding frames after receiving them from the wire Error tuples bubble up to Mint.WebSocket.decode/2 .","ref":"Mint.WebSocket.Extension.html#c:decode/2","title":"Mint.WebSocket.Extension.decode/2","type":"callback"},{"doc":"Invoked when encoding frames before sending them across the wire Error tuples bubble up to Mint.WebSocket.encode/2 .","ref":"Mint.WebSocket.Extension.html#c:encode/2","title":"Mint.WebSocket.Extension.encode/2","type":"callback"},{"doc":"Invoked when the WebSocket server accepts an extension This callback should be used to initialize any :state that the extension needs to operate. For example, this callback is used by the &quot;permessage-deflate&quot; extension to setup t::zlib.zstream() s and store them in state. The all_extensions argument is passed so that the extension can know about the existence and ordering of other extensions. This can be useful if a client declares multiple extensions which accomplish the same job (such as multiple compression extensions) but want to only enable one based on what the server accepts. Note that extensions are initialized in the order in which the server accepts them: any extensions preceeding this_extension in all_extensions are initialized while any extensions after this_extension are not yet initialized. Error tuples bubble up to Mint.WebSocket.upgrade/4 .","ref":"Mint.WebSocket.Extension.html#c:init/2","title":"Mint.WebSocket.Extension.init/2","type":"callback"},{"doc":"Returns the name of the WebSocket extension This should not include the parameters for the extension, such as &quot;client_max_window_bits&quot; for the &quot;permessage-deflate&quot; extension. Examples iex&gt; Mint.WebSocket.PerMessageDeflate . name ( ) &quot;permessage-deflate&quot;","ref":"Mint.WebSocket.Extension.html#c:name/0","title":"Mint.WebSocket.Extension.name/0","type":"callback"},{"doc":"Parameters to configure an extension Some extensions can be configured by negotiation between the client and server. For example &quot;permessage-deflate&quot; usually shows up as in the &quot;sec-websocket-extensions&quot; header literally like so: Sec-WebSocket-Extensions: permessage-deflate But the zlib window sizes and reset behavior can be negotiated with parameters with headers like so Sec-WebSocket-Extensions: permessage-deflate; client_no_context_takeover; client_max_window_bits=12 These can be configured by passing parameters to any element passed in the :extensions option to Mint.WebSocket.upgrade/4 . For example, one might write the above parameter configuration as [ { Mint.WebSocket.PerMessageDeflate , [ client_no_context_takeover : true , client_max_window_bits : 12 ] } ] when passing the :extensions option to Mint.WebSocket.upgrade/4 . Note that Mint.WebSocket.upgrade/4 will normalize the parameters of an extension to a list of two-tuples with string keys and values. For example, the above would be normalized to this extensions list: [ % Mint.WebSocket.Extension { name : &quot;permessage-deflate&quot; , module : Mint.WebSocket.PerMessageDeflate , params : [ { &quot;client_no_context_takeover&quot; , &quot;true&quot; } , { &quot;client_max_window_bits&quot; , &quot;12&quot; } ] , state : nil , opts : [ ] } ]","ref":"Mint.WebSocket.Extension.html#t:params/0","title":"Mint.WebSocket.Extension.params/0","type":"type"},{"doc":"A structure representing an instance of an extension Extensions are implemented as modules but passed to Mint.WebSocket as Mint.WebSocket.Extension structs with the following keys: :name - the name of the extension. When using the short-hand tuple syntax to pass extensions to Mint.WebSocket.upgrade/4 , the name is determined by calling the name/0 callback. :module - the module which implements the callbacks defined in the Mint.WebSocket.Extension behavior. :state - an arbitrary piece of data curated by the extension. For example, the &quot;permessage-deflate&quot; extension uses this field to hold t:zlib.zstream() s for compression and decompression. :params - a list with key-value tuples or atom/string keys which configure the parameters communicated to the server. All params are encoded into the &quot;sec-websocket-extensions&quot; header. Also see the documentation for params/0 . :opts - a keyword list to pass configuration to the extension. These are not encoded into the &quot;sec-websocket-extensions&quot; header. For example, :opts is used by the &quot;permessage-deflate&quot; extension to configure :zlib configuration.","ref":"Mint.WebSocket.Extension.html#t:t/0","title":"Mint.WebSocket.Extension.t/0","type":"type"},{"doc":"A WebSocket extension which compresses each message before sending it across the wire This extension is defined in rfc7692 . Options :zlib_level - (default: :best_compression ) the compression level to use for the deflation zstream. See the :zlib.deflateInit/6 documentation on the Level argument. :zlib_memory_level - (default: 8 ) how much memory to allow for use during compression. See the :zlib.deflateInit/6 documentation on the MemLevel argument.","ref":"Mint.WebSocket.PerMessageDeflate.html","title":"Mint.WebSocket.PerMessageDeflate","type":"module"},{"doc":"An error representing a failure to upgrade protocols from HTTP to WebSocket","ref":"Mint.WebSocket.UpgradeFailureError.html","title":"Mint.WebSocket.UpgradeFailureError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Mint.WebSocket.UpgradeFailureError.html#message/1","title":"Mint.WebSocket.UpgradeFailureError.message/1","type":"function"},{"doc":"Represents an error in the WebSocket protocol The Mint.WebSocketError struct is an exception, so it can be raised as any other exception.","ref":"Mint.WebSocketError.html","title":"Mint.WebSocketError","type":"exception"},{"doc":"","ref":"Mint.WebSocketError.html#t:t/0","title":"Mint.WebSocketError.t/0","type":"type"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fixed WebSocket frames are now correctly buffered when a partially received frame is split in the payload-length segment.","ref":"changelog.html#1-0-1-2022-09-18","title":"Changelog - 1.0.1 - 2022-09-18","type":"extras"},{"doc":"v1.0.0 is released! We've been using Mint.WebSocket in production for the better part of a year without trouble. v1.0.0 is code-wise the same as v0.3.0: it represents a stability milestone. Mint.WebSocket will now follow semantic versioning, so any breaking changes will result in a v2.0.0.","ref":"changelog.html#1-0-0-2022-04-12","title":"Changelog - 1.0.0 - 2022-04-12","type":"extras"},{"doc":"Changed Failure to upgrade now gives a Mint.WebSocket.UpgradeFailureError as the error when a server returns a status code other than 101 for HTTP/1 or a status code outside the range 200..299 range for HTTP/2.","ref":"changelog.html#0-3-0-2022-02-27","title":"Changelog - 0.3.0 - 2022-02-27","type":"extras"},{"doc":"This release is a breaking change from the 0.1.0 series. This update removes all instances where Mint.WebSocket would access opaque Mint.HTTP.t/0 fields or call private functions within Mint.HTTP1 , so now Mint.WebSocket should be more compatible with future changes to Mint. Upgrade guide First, add the scheme argument to calls to Mint.WebSocket.upgrade/5 . For connections formed with Mint.HTTP.connect(:http, ..) , use the :ws scheme. For Mint.HTTP.connect(:https, ..) , use :wss . - Mint.WebSocket.upgrade(conn, path, headers) + Mint.WebSocket.upgrade(scheme, conn, path, headers) Then replace calls to Mint.HTTP.stream/2 and/or Mint.HTTP.recv/3 and Mint.HTTP.stream_request_body/3 with the new Mint.WebSocket wrappers. This is safe to do even when these functions are being used to send and receive data in normal HTTP requests: the functionality only changes when the connection is an established HTTP/1 WebSocket. Added Added Mint.WebSocket.stream/2 which wraps Mint.HTTP.stream/2 Added Mint.WebSocket.recv/3 which wraps Mint.HTTP.recv/3 Added Mint.WebSocket.stream_request_body/3 which wraps Mint.HTTP.stream_request_body/3 Changed Changed function signature of Mint.Websocket.upgrade/5 to accept the WebSocket's scheme ( :ws or :wss ) as the first argument Added an optional opts argument to Mint.WebSocket.new/5 to control active vs. passive mode on the socket Restricted compatible Mint versions to ~&gt; 1.4 Mint.WebSocket now uses Mint.HTTP.get_protocol/1 which was introduced in 1.4.0 .","ref":"changelog.html#0-2-0-2022-02-17","title":"Changelog - 0.2.0 - 2022-02-17","type":"extras"},{"doc":"Fixed Fixed typespec for Mint.WebSocket.new/4","ref":"changelog.html#0-1-4-2021-07-06","title":"Changelog - 0.1.4 - 2021-07-06","type":"extras"},{"doc":"Fixed Switch from using Bitwise.bor/2 to :erlang.bor/2 for compatibility with Elixir &lt; 1.10","ref":"changelog.html#0-1-3-2021-07-02","title":"Changelog - 0.1.3 - 2021-07-02","type":"extras"},{"doc":"Fixed Switch from using Bitwise.bxor/2 to :erlang.bxor/2 for compatibility with Elixir &lt; 1.10","ref":"changelog.html#0-1-2-2021-07-02","title":"Changelog - 0.1.2 - 2021-07-02","type":"extras"},{"doc":"Fixed Close frame codes and reasons are now nillable instead of defaulted The WebSocket spec does not require that a code and reason be included for all close frames","ref":"changelog.html#0-1-1-2021-07-01","title":"Changelog - 0.1.1 - 2021-07-01","type":"extras"},{"doc":"Added Initial implementation includes HTTP/1.1 and HTTP/2 support and extensions","ref":"changelog.html#0-1-0-2021-06-30","title":"Changelog - 0.1.0 - 2021-06-30","type":"extras"}]